security:
    enable_authenticator_manager: true
    # https://symfony.com/doc/current/security.html#registering-the-user-hashing-passwords
    password_hashers:
        Symfony\Component\Security\Core\User\PasswordAuthenticatedUserInterface: 'auto'
    # https://symfony.com/doc/current/security.html#loading-the-user-the-user-provider
    providers:
        db_user_provider:
            entity:
                class: App\Entity\User
                property: email
        users_in_memory: { memory: null }

    firewalls:
        dev:
            pattern: ^/(_(profiler|wdt)|css|images|js)/
            security: false

        login:
            pattern: ^/api/login
            stateless: true
            provider: db_user_provider 
            json_login:
                check_path: /api/login_check
                success_handler: lexik_jwt_authentication.handler.authentication_success
                failure_handler: lexik_jwt_authentication.handler.authentication_failure

        api:
            pattern: ^/api
            stateless: true
            entry_point: jwt
            provider: db_user_provider 
            json_login:
                check_path: /api/login_check 
                success_handler: lexik_jwt_authentication.handler.authentication_success
                failure_handler: lexik_jwt_authentication.handler.authentication_failure
            jwt: ~
            refresh_jwt:
                check_path: /api/token/refresh
                provider: db_user_provider 

        main:
            lazy: true
            provider: db_user_provider
            form_login:
                login_path: app_login
                check_path: app_login
                default_target_path: admin_index
                enable_csrf: true
            logout:
                path: app_logout
                # where to redirect after logout
                target: app_login



            # lazy: true
            # provider: db_user_provider
            # entry_point: app_login
            # custom_authenticator: App\Security\AppCustomAuthenticator
            # logout:
            #     path: app_logout
            #     # where to redirect after logout
            #     # target: app_any_route

            # form_login:
            #     login_path: app_login
            #     check_path: app_login

            # remember_me:
            #     secret: '%kernel.secret%'
            #     lifetime: 604800
            #     path: /
            #     always_remember_me: true


    # Easy way to control access for large sections of your site
    # Note: Only the *first* access control that matches will be used
    access_control:
        - { path: ^/api/(login|token/refresh), roles: PUBLIC_ACCESS }
        - { path: ^/api/(location/all-establishments), roles: PUBLIC_ACCESS }
        - { path: ^/api/(janaza/all), roles: PUBLIC_ACCESS }
        - { path: ^/api/(login|register|recover-password|confirm-reset-code), roles: PUBLIC_ACCESS }
        # - { path: ^/api/send-test-notification, roles: PUBLIC_ACCESS }
        # - { path: ^/api/update-janaza, roles: PUBLIC_ACCESS }
        # /edit-janaza/{id}
        
        - { path: ^/api, roles: IS_AUTHENTICATED_FULLY }
        - { path: ^/admin/login, roles: IS_AUTHENTICATED_ANONYMOUSLY }
        - { path: ^/admin, roles: ROLE_ADMIN }
        - { path: ^/admin, roles: ROLE_ADMIN }
        # - { path: ^/profile, roles: ROLE_USER }

when@test:
    security:
        password_hashers:
            # By default, password hashers are resource intensive and take time. This is
            # important to generate secure password hashes. In tests however, secure hashes
            # are not important, waste resources and increase test times. The following
            # reduces the work factor to the lowest possible values.
            Symfony\Component\Security\Core\User\PasswordAuthenticatedUserInterface:
                algorithm: auto
                cost: 4 # Lowest possible value for bcrypt
                time_cost: 3 # Lowest possible value for argon
                memory_cost: 10 # Lowest possible value for argon
